"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initRedisConnection = exports.MicroRedisConnection = void 0;
const redis = __importStar(require("redis"));
class MicroRedisConnection {
    closeClients() {
        return __awaiter(this, void 0, void 0, function* () {
            function disconnect(redis) {
                return __awaiter(this, void 0, void 0, function* () {
                    if ((redis === null || redis === void 0 ? void 0 : redis.isReady) && redis.isOpen) {
                        yield redis.disconnect();
                    }
                });
            }
            yield disconnect(this.pub);
            this.pub = undefined;
            yield disconnect(this.sub);
            this.sub = undefined;
        });
    }
    initClients() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            yield this.closeClients();
            const host = (_a = this.options.host) !== null && _a !== void 0 ? _a : "localhost";
            const port = (_b = this.options.port) !== null && _b !== void 0 ? _b : 6379;
            const opt = Object.assign({}, this.options);
            delete opt.host;
            delete opt.port;
            opt.url = `redis://${host}:${port}`;
            const pub = redis.createClient(opt);
            const sub = redis.createClient(opt);
            this.pub = pub;
            this.sub = sub;
            yield Promise.all([pub.connect(), sub.connect()]);
        });
    }
}
exports.MicroRedisConnection = MicroRedisConnection;
function initRedisConnection() {
    this.closeClients = MicroRedisConnection.prototype.closeClients.bind(this);
    this.initClients = MicroRedisConnection.prototype.initClients.bind(this);
    Object.defineProperty(this, "prefix", {
        configurable: true,
        enumerable: true,
        get: () => { var _a; return (_a = this.options.prefix) !== null && _a !== void 0 ? _a : ""; },
    });
}
exports.initRedisConnection = initRedisConnection;
